TITLE   'in'
SELECT
XERRLIM=0.0001
CHANGELIM =0.01
gridlimit=2

COORDINATES
cartesian3
VARIABLES
U
DEFINITIONS    { parameter definitions }
eps_per eps_a n_o n_e
eps0=8.854e-12
Lambda=0.63e-6 {wave length for testing beam}


 !SHELL
L_shell=2.E-4
n_shell=1.517
!SAG
L_sag=0.72E-03
eps_sp=1
n_sp=1

!LC layer
K=1.37E-11
eps_per_lc=5.3
eps_a_lc=16.4
n_e_lc=1.799
n_o_lc=1.527
!Theta02=6
!Theta01=6

L=25E-06
!GLASS LAYER
eps_glass=7.75
n_glass=1.523
L_glass=0.55E-3

R0=0.006 !Lens width
H1=L_glass
H2=L_sag
H3=L_shell
H4=0
U0=160

RR=0.003                { spherical shell projection radii onto XOY plane}
H=L_shell+L_sag+L_glass+L		{Total thickness}
R1=(RR^2+H2^2)/2/H2
RR2=sqrt(2*R1*(H2+H3)+h3^2-H2^2)	{ spherical shell  radii}
 D=1.2*RR2
z1=sqrt((x^2+y^2)-RR^2)		{distance from sphere centre to the bottom of spherical shell}
Zsphere = (sqrt(R1^2-(x^2+y^2))-R1+H1+H2  )	{z-coordinate of shperical surface }
Zshell = (sqrt((R1+H3)^2-(x^2+y^2))-R1+H1+H2  )

Phi=0 Theta=if (z<=0) then -(1.5-exp(-(x^2+y^2)/(2/3*RR)^2))*sin(pi*z/L) else 0
nx=cos(Theta)*cos(Phi) ny=cos(Theta)*sin(Phi) nz=sin(Theta)
N=vector(nx,ny,nz)
epsxx=eps0*(eps_per+eps_a*1/2*(1+cos(2*Theta))*(cos(Phi))^2)
epsyy=eps0*(eps_per+eps_a*(cos(Theta)*sin(Phi))^2)
epszz=eps0*(eps_per+eps_a*1/2*(1-cos(2*Theta)))
epsxz=eps0*eps_a*cos(Theta)*sin(Theta)*cos(Phi)
epszx=eps0*eps_a*cos(Theta)*sin(Theta)*cos(Phi)
epsxy=eps0*eps_a*cos(Theta)*cos(Theta)*cos(Phi)*Sin(Phi)
epsyx=eps0*eps_a*cos(Theta)*cos(Theta)*cos(Phi)*Sin(Phi)
epsyz=eps0*eps_a*cos(Theta)*sin(Theta)*sin(Phi)
epszy=eps0*eps_a*cos(Theta)*sin(Theta)*sin(Phi)
alpha=arccos((R1-L_sag)/(R1+L_shell))/pi*180
R_0=(R1+L_shell)*sin(alpha/180*pi)

Ex=-dx(U)  Ey=-dy(U) Ez=-dz(U)	{ Field components }
E=vector(Ex,Ey,Ez)  Em=magnitude(E)


D_x=(epsxx*Ex+epsxz*Ez+epsxy*Ey)
D_y=(epsyy*Ey+epsyz*Ez+epsyx*Ex)
D_z=(epszx*Ex+epszz*Ez+epszy*Ey)
D_el=vector(D_x,D_y,D_z)
transfermesh('transfer_U0_0_3D.dat',U1)
INITIAL VALUES
 U=U0*z/H
EQUATIONS
U: div(D_el)=0

EXTRUSION { Limiting surfaces }
SURFACE 'Bottom' z=-L
LAYER  'LC'
SURFACE 'Top of LC' z=0
LAYER 'Glass'
SURFACE 'Top of glass' z=H1
LAYER 'sag'
SURFACE 'Sag Top' z = max(Zsphere,H1)
LAYER 'shell'
SURFACE 'Top of shell' z=max(Zshell,H1)
layer 'air'
SURFACE 'Top' z=H3+H2+H1+H4

BOUNDARIES       { The domain definition }
Surface 'Bottom' value( U)=0
Surface 'Top of LC'
Surface 'Top of glass'
SURFACE 'Sag Top'  value( U)=U0
SURFACE 'Top of shell'
Surface 'Top'

Region 'BOX' eps_a=0 eps_per=1 n_o=1 n_e=1
start (-D,-D) natural(U)=epsyz*Ez  line to (D,-D) natural(U)=-epsxz*Ez  line to (D,D)
natural(U)=-epsyz*Ez  line to (-D,D) natural(U)=epsxz*Ez  line to close	{cartesian box}

REGION  'Domain'

LAYER  'LC' eps_per=eps_per_LC  eps_a=eps_a_LC n_o=n_o_LC  n_e=n_e_LC
LAYER "glass" eps_a=0 eps_per=eps_glass n_o=n_glass n_e=n_glass
LAYER 'sag' eps_a=0 eps_per=eps_sp n_o=n_sp n_e=n_sp
LAYER 'shell' eps_a=0 eps_per=eps_glass n_o=n_shell n_e=n_shell
layer 'air' eps_a=0 eps_per=1 n_o=1 n_e=1
start (-D,-D) natural(U)=0  line to (D,-D) natural(U)=0  line to (D,D)
natural(U)=0  line to (-D,D) natural(U)=0  line to close		

Limited REGION 2
LAYER 'shell' eps_a=0 eps_per=eps_glass n_o=n_shell n_e=n_shell
LAYER  'sag' eps_a=0 eps_per=eps_sp n_o=n_sp n_e=n_sp
LAYER "glass" eps_a=0 eps_per=eps_glass n_o=n_glass n_e=n_glass
START 'Ring2' (0,RR2) natural(U)=0   ARC(CENTER=0,0) ANGLE=-360 TO CLOSE	

Limited REGION 3
LAYER  'sag' eps_a=0 eps_per=eps_sp n_o=n_sp n_e=n_sp
LAYER "glass" eps_a=0 eps_per=eps_glass n_o=n_glass n_e=n_glass
START 'Ring' (0,RR) natural(U)=0  ARC(CENTER=0,0) ANGLE=-360 TO CLOSE	

MONITORS         { show progress }
grid(x,z) on y=0 grid (y,z) on x=0
Surface(U-U1) on z=-(L/2)
contour(U-U1) on x=0
contour(U-U1) on y=0
Surface(Theta) on z=-L/2
Surface(Theta) on x=0
Surface(Theta) on y=0

elevation(Theta)  from(0,0,-(L)) to (0,0,0)
ELEVATION(Theta) FROM (-D,0,-(L/2)) to (D,0,-(L/2))
ELEVATION(Theta) FROM (0,-D,-(L/2)) to (0,D,-(L/2))

PLOTS            { save result displays }
 contour( U) on x=0 contour( U) on y=0  Surface (U) on z=-L/2

elevation(Ez)  from(0,0,-L) to (0,0,H2+H1+H3)
elevation(Ez)  from(-D,0,-L/2) to (D,0,-L/2)
elevation(Ex)  from(0,0,-L) to (0,0,H2+H1+H3)
elevation(Ex) from(-D,0,-L/2) to (D,0,-L/2)
elevation(Ey)  from(0,0,-L) to (0,0,H2+H1+H3)
elevation(Ey)  from(-D,0,-L/2) to (D,0,-L/2)

elevation(Theta)  from(0,0,-(L)) to (0,0,0)
ELEVATION(Theta) FROM (-D,0,-(L/2)) to (D,0,-(L/2))
 ELEVATION(Theta) FROM (0,-D,-(L/2)) to (0,D,-(L/2))
Surface(Theta) on z=-L/2
Surface(Theta) on x=0
Surface(Theta) on y=0

transfer(U) file="transfer_U0_3D.dat"
END

